//----------------------------------//
//                                  //
//       Slidziu nuoma              //
//                                  //
//----------------------------------//

#include <iostream>
#include <iomanip>
#include <climits>
#include <fstream>
#include <vector>
using namespace std;
//------------------------------------------------------------
struct Ski
{
    string   name;
    long     number; // Inventorizacijos numeris
    string   type;  // "Suit","Boots","Sticks","Glasses","Skis"
    int      year;
    double   dayPrice;
    int      rentedByCustomer;  // numeruosime nuo 1
    int      rentsNumber; // isnuomavimo kartu kiekis
    double   moneyEarned;
};
typedef vector<Ski> Skis;
//------------------------------------------------------------
struct Customer
{
    string   name;
    string   surname;
    string   personalN;// asmens kodas
    double   moneyEarned;
};
typedef vector<Customer> Customers;
//------------------------------------------------------------
void printSkis      (const Skis&     skis);
void printCustomers (const Customers&  customers);
void addSki         (      Skis&     skis);
void addCustomer    (      Customers&  customers);
void rentSki        (      Skis&     skis, Customers& customers);
void info           (      Skis&     skis, Customers& customers); // informacija apie slides
void returnSki      (      Skis&     Skis);
void freeSkis       (      Skis&     Skis); // Laisvos slides
void popularSki     (      Skis&     Skis); // Populiariausios slides
void moreMoneySki   (      Skis&     Skis); // Daugiausiai pinigu uzdirbusios
void load           (      Skis&     skis, Customers& customers);
void save           (const Skis&     skis, const Customers&  customers  );
//------------------------------------------------------------
void printMenu()
{
    cout << endl
         << "\t Slidziu nuoma:" << endl
         << "\t 1 - spausdinti slides"       << endl
         << "\t 2 - prideti naujas slides"   << endl
         <<endl
         << "\t 3 - spausdinti klientus"     << endl
         << "\t 4 - prideti nauja klienta"   << endl
         <<endl
         << "\t 5 - isnuomuoti klientui"     << endl
         << "\t 6 - slides grazintos"        << endl
         << "\t 7 - laisvos/isnuomuotos slides"  << endl
         << "\t 8 - pasirinkto kliento issinuomuota iranga"  <<endl
         << "\t 9 - populiariausia iranga"  <<endl
         << "\t 10 - daugiausiai uzdirbusi iranga" << endl
         << endl
         << "\t 0 - baigti darba"   << endl;
}
//------------------------------------------------------------
int main ()
{
    Skis       skis;
    Customers  customers;

    load ( skis,customers);
    for (;;)
    {
        cout << "--------------------------------------------------------\n";
        cout << "(m - rodyti meniu) > ";
        string key;
        cin >> key;
             if (key == "0") break;
        else if (key == "m") printMenu      ();
        else if (key == "1") printSkis    (skis);
        else if (key == "2") addSki       (skis);
        else if (key == "3") printCustomers (customers);
        else if (key == "4") addCustomer    (customers);
        else if (key == "5") rentSki      (skis, customers);
        else if (key == "6") returnSki    (skis);
        else if (key == "7") freeSkis     (skis);
        else if (key == "8") info    (skis, customers);
        else if (key == "9") popularSki   (skis);
        else if (key == "10") moreMoneySki (skis);

        else cout << endl << "Neteisinga komanda..." << endl;
    }
    save ( skis, customers );
}
//------------------------------------------------------------
void printSkis    (const Skis&    skis)
{
    cout << "Slidziu kiekis: " << skis.size() << endl;
    for (int i = 0;  i < skis.size();  i++)
    {
        cout << (i+1)
             << ". "               << skis[i].rentedByCustomer
             << "\t"               << skis[i].name
             << "  (dienos kaina " << skis[i].dayPrice    << "Lt)"
             << "  ("              << skis[i].moneyEarned << "Lt)"
             << "\t tipas-"        << skis[i].type
             << "\t"               << skis[i].year        << "metai"
             << "   nr."           << skis[i].number
             << endl;
    }
}
//------------------------------------------------------------
void printCustomers (const Customers& customers)
{
    cout << "Klietu kiekis: " << customers.size() << endl;
    for (int i = 0;  i < customers.size();  i++)
    {
        cout << (i+1)
             << ". ("      << customers[i].moneyEarned << "Lt)"
             << "\t"       << customers[i].name
             << "\t"       << customers[i].surname
             << "\t(a/k "  << customers[i].personalN << ")"
             << endl;
    }
}
//------------------------------------------------------------
void addSki (Skis& skis)
{
    cin.ignore(INT_MAX, '\n'); // ignoruojam uzsilikusi klaviaturos ENTER
    Ski ski;
    cout << "Iveskite naujas slides:" << endl;
    cout << "    pavadinimas                    : ";  getline(cin, ski.name);
    cout << "    inventorizacijos numeris       : ";  cin >> ski.number;
    cout << "    Skis/Boots/Suit/Glasses/Sticks : ";  cin >> ski.type;
    cout << "    kaina dienai                   : ";  cin >> ski.dayPrice;
    cout << "    metai                          : ";  cin >> ski.year;
    ski.rentedByCustomer =  0;
    ski.moneyEarned      =  0;
    ski.rentsNumber      =  0;
    skis.push_back(ski);
}
//------------------------------------------------------------
void addCustomer (Customers& customers)
{
    cin.ignore(INT_MAX, '\n'); // ignoruojam uzsilikusi klaviaturos ENTER
    Customer customer;
    cout << "Iveskite nauja klienta:" << endl;
    cout << "    vardas : ";  getline(cin, customer.name);
    cout << "    pavarde: ";  getline(cin, customer.surname);
    cout << "    asmens kodas: "; getline(cin, customer.personalN);
    customer.moneyEarned = 0;
    customers.push_back(customer);
}
//------------------------------------------------------------
void rentSki (Skis& skis, Customers& customers)
{
     int skiNo = 0;
     printSkis (skis);
     cout << "Iveskit slidziu eiles numeri: ";
     cin  >> skiNo;
     if (skiNo <= 0  ||  skiNo > skis.size())
     {
         cout << "KLAIDA: nera slidziu su ivestu eiles numeriu." <<endl;
         return;
     }
     if (skis[skiNo-1].rentedByCustomer != 0)
     {
         cout << "KLAIDA: slides jau yra isnuomotos." << endl;
         return;
     }

     int customerNo = 0;
     printCustomers (customers);
     cout << "Pasirinkite kliento eiles numeri: ";
     cin  >> customerNo;
     if (customerNo <= 0  ||  customerNo > customers.size())
     {
         cout << "KLAIDA: nera kliento su ivestu eiles numeriu." << endl;
         return;
     }

     int dayCount;
     cout << "Keliom dienom nuomuosime        : ";
     cin  >> dayCount;
     skis[skiNo-1].rentedByCustomer   = customerNo;
     skis[skiNo-1].rentsNumber = skis[skiNo-1].rentsNumber + 1;
     skis[skiNo-1].moneyEarned       += dayCount * skis[skiNo-1].dayPrice;
     customers[customerNo-1].moneyEarned += dayCount * skis[skiNo-1].dayPrice;
}
//------------------------------------------------------------
void returnSki    (Skis&     skis)
{
     int skiNo = 0;
     printSkis (skis);
     cout << "Iveskit slidziu eiles numeri: ";
     cin  >> skiNo;
     if (skiNo <= 0  ||  skiNo > skis.size())
     {
         cout << "KLAIDA: nera slidziu su ivestu eiles numeriu." << endl;
         return;
     }
     skis[skiNo-1].rentedByCustomer = 0;
}
//-----------------------------------------------------------
void freeSkis (Skis& skis)
{
   string a;
   cout << "Apie kokias slides norite suzinuoti? (L - laisvos, I - isnuomuotos)";
   cin >> a;
   if ( a == "L" )
   {
       cout <<"Laisvos slides: " << endl;
       for (int i=0; i<skis.size();i++)
       {
           if (skis[i].rentedByCustomer == 0)
           cout << (i+1)
                << "." << skis[i].rentedByCustomer
                << "\t" << skis[i].name
                << "  (dienos kaina " << skis[i].dayPrice << "Lt)"
                << "  (" << skis[i].moneyEarned << "Lt)"
                << "\t tipas-" << skis[i].type
                << "\t" << skis[i].year << "metai"
                << "   nr." << skis[i].number
                << endl;
        }
   }
   else if ( a == "I" )
   {
       cout << "Isnuomuotos slides: " << endl;
       for (int i=0;i<skis.size(); i++)
       {
           if (skis[i].rentedByCustomer != 0)
           cout << (i+1)
                << "." << skis[i].rentedByCustomer
                << "\t" << skis[i].name
                << "  (dienos kaina " <<skis[i].dayPrice << "Lt)"
                << "  (" << skis[i].moneyEarned << "Lt)"
                << "\t tipas-" <<skis[i].type
                << "\t" <<skis[i].year << "metai"
                << "   nr." <<skis[i].number
                << endl;
       }
   }
   else cout << endl << "Neteisinga komanda..." << endl  ;
}
//--------------------------------------------------------------------
void popularSki (Skis&   skis)
{
    int maxIndex = 0;
    for (int i = 0;  i < skis.size();  i++)
        if(skis[i].rentsNumber > skis[maxIndex].rentsNumber)
               maxIndex = i;
    if (skis[maxIndex].rentsNumber != 0)
    {
        cout << "Daugiausiai kartu isnuomotos slides: " << endl
             << skis[maxIndex].name
             << "   nr." << skis[maxIndex].number
             << "\t"  << skis[maxIndex].year << "metai"
             << "  ("  << skis[maxIndex].moneyEarned << "Lt)"
             << "\t tipas-"   << skis[maxIndex].type
             << "  (dienos kaina " << skis[maxIndex].dayPrice << "Lt)"
             << endl;
    }
    else cout << "Nei vienos slides dar nebuvo isnuomuotos.." << endl;
}
//-----------------------------------------------------------------------
void moreMoneySki (      Skis&     skis)
{
    int maxIndex = 0;
    for (int i = 0;  i < skis.size();  i++)
         if(skis[i].moneyEarned > skis[maxIndex].moneyEarned)
               maxIndex = i;
    if (skis[maxIndex].moneyEarned != 0)
    {
        cout << "Daugiausiai uzdirbusios slides: " << endl
             << skis[maxIndex].name
             << "   nr." << skis[maxIndex].number
             << "\t"  << skis[maxIndex].year << "metai"
             << "  ("  << skis[maxIndex].moneyEarned << "Lt)"
             << "\t tipas-"   << skis[maxIndex].type
             << "  (dienos kaina " << skis[maxIndex].dayPrice << "Lt)"
             << endl;
    }
    else cout << "Nei vienos slides dar nebuvo isnuomuotos.." << endl;
}
//------------------------------------------------------------------
void info    (Skis& skis, Customers& customers)
{
    printCustomers (customers);
    cout << "Iveskite kliento numeri: " ;
    int custSkis = 0;
    cin >> custSkis;
    if (custSkis <= 0  ||  custSkis > customers.size())
    {
        cout << "KLAIDA: nera kliento su ivestu eiles numeriu." << endl;
        return;
    }
    cout << "Pasirinkto kliento slides: " << endl;
    for (int i = 0;  i < skis.size();  i++)
    {
        if(skis[i].rentedByCustomer == custSkis)
        {
            cout << endl
                 << skis[i].name
                 << "   nr." << skis[i].number
                 << "\t"  << skis[i].year << "metai"
                 << "  ("  << skis[i].moneyEarned << "Lt)"
                 << "\t tipas-"   << skis[i].type
                 << "  (dienos kaina " << skis[i].dayPrice << "Lt)"
                 << endl; 
        }
    } 
}
//-------------------------------------------------------------------
void load( Skis& skis,Customers& customers)
{
    int skisCount = 0;
    Ski ski;
    ifstream inFile ;
    inFile.open("duom.txt");
    inFile >> skisCount;
    for (int i = 0;  i < skisCount;  i++)
    {
        inFile >> ski.name >> ski.number >> ski.year >> ski.dayPrice >> ski.type;
        ski.moneyEarned = 0;
        ski.rentedByCustomer = 0;
        ski.rentsNumber = 0;
        skis.push_back(ski);
    }
    int customersCount = 0;
    Customer customer;
    inFile >> customersCount;
    for (int i = 0;  i < customersCount;  i++)
    {
        inFile >> customer.name >> customer.surname >> customer.personalN;
        customer.moneyEarned = 0;
        customers.push_back(customer);
    }
    inFile.close();
}
//--------------------------------------------------------------------
void save ( const Skis& skis, const Customers& customers)
{
    Ski ski; 
    Customer customer;
    ofstream outFile;
    outFile.open("rez.txt");
    outFile << skis.size() << endl;
    for (int i = 0;  i < skis.size();  i++)
    {
        outFile << skis[i].name << " "
                << skis[i].number << " "
                << skis[i].type << " "
                << skis[i].year << " "
                << "(Dienos kaina: " << skis[i].dayPrice << "Lt) "
                << skis[i].rentedByCustomer << " "
                << "(Uzdirbo: " << skis[i].moneyEarned << "Lt) "
                << "(Buvo isnuomuotos " << skis[i].rentsNumber << "k.)"
                << endl;
    }
    outFile << customers.size() << endl;
    for (int i = 0;  i < customers.size();  i++)
    {
        outFile << customers[i].name << " "
                << customers[i].surname << " "
                <<"(a/k " << customers[i].personalN << ") "
                << "(Isleido: " << customers[i].moneyEarned << "Lt) "
                << endl;
    }
    outFile.close();
}

